; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : AdvancedDateFormatting
; Nom du fichier : AdvancedDateFormatting - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume Saumure
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 15-02-2015
; Mise  jour : 05-06-2018
; Code PureBasic : V5.62
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule AdvancedDateFormatting
  
  Declare Reset()
  Declare SetOrdinal(OrdinalSequence.s)
  Declare SetMonth(MonthID, ShortMonthName.s, LongMonthName.s)
  Declare SetDay(DayID, ShortDayName.s, LongDayName.s)
  Declare SetEditorText(TextID.l, Text.s)
  Declare.s Format(Mask.s, Date.i)
  Declare.s DateMaskEditor()
  
EndDeclareModule

Module AdvancedDateFormatting
  
  Structure Instance
    
    ShortMonth.s[12]
    LongMonth.s[12]
    ShortDay.s[7]
    LongDay.s[7]
    Ordinal.s[31]
    DateMaskEditor.s[20]
    
  EndStructure
  
  Global Instance.Instance
 
  Procedure Reset()
    
    For ShortMonthID = 0 To 11
      Instance\ShortMonth[ShortMonthID] = ""
      Instance\LongMonth[ShortMonthID] = ""
    Next
    
    For ShortDayID = 0 To 6
      Instance\ShortDay[ShortDayID] = ""
      Instance\LongDay[ShortDayID] = ""
    Next
    
    For OrdinalID = 0 To 30
      Instance\Ordinal[OrdinalID] = ""
    Next
    
    For DateMaskEditorID = 0 To 19
      Instance\DateMaskEditor[DateMaskEditorID] = ""
    Next
    
  EndProcedure
  
  Procedure SetMonth(MonthID, ShortMonthName.s, LongMonthName.s)
    
    Instance\ShortMonth[MonthID] = ShortMonthName
    Instance\LongMonth[MonthID] = LongMonthName
    
  EndProcedure
  
  Procedure SetDay(DayID, ShortDayName.s, LongDayName.s)
    
    Instance\ShortDay[DayID] = ShortDayName
    Instance\LongDay[DayID] = LongDayName
    
  EndProcedure
  
  Procedure SetOrdinal(OrdinalSequence.s)
    
    ;SetOrdinal("st:1,21,31|nd:2,22|rd:3,23|th:x")
    ;SetOrdinal("er: 1|: x")
    
    NewList Blocks.s()
    BlockMax = CountString(OrdinalSequence, "|") + 1
    
    For BlockID = 1 To BlockMax
      AddElement(Blocks())
      Blocks() = StringField(OrdinalSequence, BlockID, "|")
    Next
    
    ForEach Blocks()
      
      Symbol.s = StringField(Blocks(), 1, ":")
      DaysToApply.s = Trim(StringField(Blocks(), 2, ":"))
      
      If DaysToApply = "x"
        
        For OrdinalID = 0 To 30
          
          If Instance\Ordinal[OrdinalID] = ""
            Instance\Ordinal[OrdinalID] = Symbol
          EndIf
          
        Next
        
      Else
        
        DaysToApplyMax = CountString(DaysToApply, ",") + 1
        
        For DaysToApplyID = 1 To DaysToApplyMax
          Index = Val(StringField(DaysToApply, DaysToApplyID, ","))-1
          Instance\Ordinal[Index] = Symbol
        Next
        
      EndIf
      
      Blocks() = ""
      
    Next
    
    FreeList(Blocks())
  
  EndProcedure
  
  Procedure SetEditorText(TextID.l, Text.s)
    
    Instance\DateMaskEditor[TextID] = Text
    
  EndProcedure
 
  Procedure.s Format(Mask.s, Date.i)
    
    FormattedDate.s = FormatDate(Mask, Date)
    
    If FindString(FormattedDate, "%smm", 1)
      FormattedDate = ReplaceString(FormattedDate, "%smm", Instance\ShortMonth[Month(Date) - 1], #PB_String_NoCase, 1)
    EndIf 
    
    If FindString(FormattedDate, "%lmm", 1)
      FormattedDate = ReplaceString(FormattedDate, "%lmm", Instance\LongMonth[Month(Date) - 1], #PB_String_NoCase, 1)
    EndIf 
    
    If FindString(FormattedDate, "%sdd", 1)
      FormattedDate = ReplaceString(FormattedDate, "%sdd", Instance\ShortDay[DayOfWeek(Date)], #PB_String_NoCase, 1)
    EndIf 
    
    If FindString(FormattedDate, "%ldd", 1)
      FormattedDate = ReplaceString(FormattedDate, "%ldd", Instance\LongDay[DayOfWeek(Date)], #PB_String_NoCase, 1)
    EndIf 
    
    If FindString(FormattedDate, "%ord", 1)
      FormattedDate = ReplaceString(FormattedDate, "%ord", Instance\Ordinal[Day(Date)-1], #PB_String_NoCase, 1)
    EndIf 
    
    ProcedureReturn FormattedDate
  EndProcedure
  
  Procedure.s DateMaskEditor()
    
    Handle = OpenWindow(#PB_Any, 0, 0, 345, 460, Instance\DateMaskEditor[0], #PB_Window_SystemMenu|#PB_Window_ScreenCentered)
    
    If IsWindow(Handle)
      
      FrameGadget(#PB_Any, 5, 5, 335, 305, Instance\DateMaskEditor[1])
      TextGadget(#PB_Any, 10, 30, 325, 25, "%dd : " + Instance\DateMaskEditor[2], #PB_Text_Center)
      TextGadget(#PB_Any, 10, 55, 325, 25, "%sdd : " + Instance\DateMaskEditor[3], #PB_Text_Center)
      TextGadget(#PB_Any, 10, 80, 325, 25, "%ldd : " + Instance\DateMaskEditor[4], #PB_Text_Center)
      TextGadget(#PB_Any, 10, 105, 325, 25, "%ord : " + Instance\DateMaskEditor[5], #PB_Text_Center)
      TextGadget(#PB_Any, 10, 130, 325, 25, "%mm : " + Instance\DateMaskEditor[6], #PB_Text_Center)
      TextGadget(#PB_Any, 10, 155, 325, 25, "%smm : " + Instance\DateMaskEditor[7], #PB_Text_Center)
      TextGadget(#PB_Any, 10, 180, 325, 25, "%lmm : " + Instance\DateMaskEditor[8], #PB_Text_Center)
      TextGadget(#PB_Any, 10, 205, 325, 25, "%yyyy : " + Instance\DateMaskEditor[9], #PB_Text_Center)
      TextGadget(#PB_Any, 10, 230, 325, 25, "%hh : " + Instance\DateMaskEditor[10], #PB_Text_Center)
      TextGadget(#PB_Any, 10, 255, 325, 25, "%ii : " + Instance\DateMaskEditor[11], #PB_Text_Center)
      TextGadget(#PB_Any, 10, 280, 325, 25, "%ss : " + Instance\DateMaskEditor[12], #PB_Text_Center)
      
      FrameGadget(#PB_Any, 5, 315, 335, 100, Instance\DateMaskEditor[13])
      MaskPreview = TextGadget(#PB_Any, 10, 340, 325, 30, "", #PB_Text_Center|#PB_Text_Border)
      MaskEdit = StringGadget(#PB_Any, 10, 375, 325, 30, "")
      
      Button_OK = ButtonGadget(#PB_Any, 5, 420, 165, 30, Instance\DateMaskEditor[14])
      Button_Cancel = ButtonGadget(#PB_Any, 175, 420, 165, 30, Instance\DateMaskEditor[15])
      
      AddKeyboardShortcut(Handle, #PB_Shortcut_Escape, 123)
      
      Repeat
        
        Select WaitWindowEvent()
            
          Case #PB_Event_CloseWindow
            
            Select EventWindow()
                
              Case Handle
                RemoveKeyboardShortcut(Handle, #PB_Shortcut_Escape)
                CloseWindow(Handle)
                Break
                
            EndSelect
            
          Case #PB_Event_Menu
            
            Select EventMenu()
                
              Case 123
                RemoveKeyboardShortcut(Handle, #PB_Shortcut_Escape)
                CloseWindow(Handle)
                Break
                    
            EndSelect
            
          Case #PB_Event_Gadget
            
            Select EventGadget()
                
              Case MaskEdit
                SetGadgetText(MaskPreview, Format(GetGadgetText(MaskEdit), Date(Year(Date()), Month(Date()), 1, Hour(Date()), Minute(Date()), Second(Date()))))

              Case Button_OK
                RemoveKeyboardShortcut(Handle, #PB_Shortcut_Escape)
                DateMask.s = GetGadgetText(MaskEdit)
                CloseWindow(Handle)
                Break
                
              Case Button_Cancel
                RemoveKeyboardShortcut(Handle, #PB_Shortcut_Escape)
                CloseWindow(Handle)
                Break
                
            EndSelect
            
        EndSelect
        
      ForEver
      
    EndIf
    
    ProcedureReturn DateMask
  EndProcedure
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  AdvancedDateFormatting::SetMonth(00, "Jan", "January")
  AdvancedDateFormatting::SetMonth(01, "Feb", "February")
  AdvancedDateFormatting::SetMonth(02, "Mar", "March")
  AdvancedDateFormatting::SetMonth(03, "Apr", "April")
  AdvancedDateFormatting::SetMonth(04, "May", "May")
  AdvancedDateFormatting::SetMonth(05, "Jun", "June")
  AdvancedDateFormatting::SetMonth(06, "Jul", "July")
  AdvancedDateFormatting::SetMonth(07, "Aug", "August")
  AdvancedDateFormatting::SetMonth(08, "Sep", "September")
  AdvancedDateFormatting::SetMonth(09, "Oct", "October")
  AdvancedDateFormatting::SetMonth(10, "Nov", "November")
  AdvancedDateFormatting::SetMonth(11, "Dec", "December")
  
  AdvancedDateFormatting::SetDay(00, "Sun", "Sunday")
  AdvancedDateFormatting::SetDay(01, "Mon", "Monday")
  AdvancedDateFormatting::SetDay(02, "Tue", "Tuesday")
  AdvancedDateFormatting::SetDay(03, "Wed", "Wednesday")
  AdvancedDateFormatting::SetDay(04, "Thu", "Thursday")
  AdvancedDateFormatting::SetDay(05, "Fri", "Friday")
  AdvancedDateFormatting::SetDay(06, "Sat", "Saturday")
  
  AdvancedDateFormatting::SetOrdinal("st:1,21,31|nd:2,22|rd:3,23|th:x")
  
  AdvancedDateFormatting::SetEditorText(0, "Date Mask Editor")
  AdvancedDateFormatting::SetEditorText(1, "Mask parts")
  AdvancedDateFormatting::SetEditorText(2, "2 digits day")
  AdvancedDateFormatting::SetEditorText(3, "3 characters day name")
  AdvancedDateFormatting::SetEditorText(4, "Long day name")
  AdvancedDateFormatting::SetEditorText(5, "Ordinal")
  AdvancedDateFormatting::SetEditorText(6, "2 digits month")
  AdvancedDateFormatting::SetEditorText(7, "3 characters month name")
  AdvancedDateFormatting::SetEditorText(8, "Long month name")
  AdvancedDateFormatting::SetEditorText(9, "4 digits year") 
  AdvancedDateFormatting::SetEditorText(10, "2 digits hours") 
  AdvancedDateFormatting::SetEditorText(11, "2 digits minutes") 
  AdvancedDateFormatting::SetEditorText(12, "2 digits seconds") 
  AdvancedDateFormatting::SetEditorText(13, "Definition") 
  AdvancedDateFormatting::SetEditorText(14, "OK") 
  AdvancedDateFormatting::SetEditorText(15, "Cancel") 
  
  Debug AdvancedDateFormatting::DateMaskEditor()
  
;   Macro AddElementEx(ListName, Element)
;     
;     AddElement(ListName)
;     ListName = Element
;     
;   EndMacro
;   
;   NewList DateMask.s()
;   
;   AddElementEx(DateMask(), "A=%yyyy, M=%mm, J=%dd")
;   AddElementEx(DateMask(), "%yyyy-%mm-%dd")
;   AddElementEx(DateMask(), "%dd-%mm-%yyyy")
;   AddElementEx(DateMask(), "%dd %lmm %yyyy")
;   AddElementEx(DateMask(), "%dd %smm %yyyy")
;   AddElementEx(DateMask(), "%ldd %lmm %dd%eds, %yyyy")
;   AddElementEx(DateMask(), "%dd-%mm-%yyyy - %hh:%ii:%ss")
;   AddElementEx(DateMask(), "%ldd - %dd %lmm %yyyy")
;   AddElementEx(DateMask(), "%lmm %dd%ord, %yyyy")
;   AddElementEx(DateMask(), "%dd%eds %lmm %yyyy")
;   AddElementEx(DateMask(), "%dd%eds %lmm %yyyy - %hh:%ii:%ss")
;   
;   Debug "; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<"
;   Debug "; Testing with the English setting"
;   Debug ""
;   
;   ForEach DateMask()
;     Debug AdvancedDateFormatting::Format(DateMask(), Date())
;   Next
;   
;   Debug ""
;   
;   For DayID = 1 To 31
;     Debug AdvancedDateFormatting::Format("%lmm %dd%eds, %yyyy", Date(Year(Date())+1, 01, DayID, 0, 0, 0))
;   Next
  

CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = --
; EnableXP
; CompileSourceDirectory