; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
; Nom du projet : Chrono
; Nom du fichier : Chrono - Module.pb
; Version du fichier : 1.0.0
; Programmation : OK
; Programm par : Guillaume
; Alias : StarBootics
; Courriel : gsaumure@cgocable.ca
; Date : 24-10-2008
; Mise  jour : 20-03-2016
; Cod pour PureBasic V5.42
; Plateforme : Windows, Linux, MacOS X
; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

DeclareModule Chrono
  
  Declare New(P_ChronoID.l)
  Declare Reset(P_ChronoID.l)
  Declare Refresh(P_ChronoID.l)
  Declare Start(P_ChronoID.l)
  Declare Stop(P_ChronoID.l)
  Declare.l Consult(P_ChronoID.l)
  Declare.s Format(P_ChronoID.l, TimeMask.s)

EndDeclareModule

Module Chrono
  
  Structure Instance
    
    ID.l
    StartTime.l
    TotalTime.l
    IsRunning.b
    
  EndStructure
  
  Global NewList Instances.Instance()
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Procdures prives <<<<<
  
  Procedure SearchInstances(P_ChronoID.l)
    
    Protected IsFoundAtIndex.l = -1
    
    ForEach Instances()
      
      If Instances()\ID = P_ChronoID
        IsFoundAtIndex = ListIndex(Instances())
        Break
      EndIf
      
    Next
    
    ProcedureReturn IsFoundAtIndex
  EndProcedure
  
  ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  ; <<<<< Procdures publiques <<<<<
 
  Procedure New(P_ChronoID.l)
    
    If SearchInstances(P_ChronoID) = -1
      AddElement(Instances())
      Instances()\ID = P_ChronoID
      Instances()\StartTime = 0
      Instances()\TotalTime = 0
      Instances()\IsRunning = #False
    Else
      Instances()\StartTime = 0
      Instances()\TotalTime = 0
      Instances()\IsRunning = #False
    EndIf
    
  EndProcedure

  Procedure Reset(P_ChronoID.l)
    
    If P_ChronoID = -1
      
      ForEach Instances()
        Instances()\ID = 0
        Instances()\StartTime = 0
        Instances()\TotalTime = 0
        Instances()\IsRunning = #False
      Next
      
      ClearList(Instances())
      
    Else
      
      If SearchInstances(P_ChronoID) <> -1
        Instances()\ID = 0
        Instances()\StartTime = 0
        Instances()\TotalTime = 0
        Instances()\IsRunning = #False
        DeleteElement(Instances(), 1)
      EndIf

    EndIf
    
  EndProcedure
  
  Procedure Refresh(P_ChronoID.l)
    
    If SearchInstances(P_ChronoID) <> -1
      Instances()\StartTime = 0
      Instances()\TotalTime = 0
      Instances()\IsRunning = #False
    EndIf
    
  EndProcedure
  
  Procedure Start(P_ChronoID.l)
    
    If SearchInstances(P_ChronoID) <> -1
      If Instances()\IsRunning = #False
        Instances()\StartTime = ElapsedMilliseconds()
        Instances()\IsRunning = #True
      EndIf
    EndIf
    
  EndProcedure
  
  Procedure Stop(P_ChronoID.l)
    
    If SearchInstances(P_ChronoID) <> -1
      If Instances()\IsRunning = #True
        Instances()\TotalTime = Instances()\TotalTime + ElapsedMilliseconds() - Instances()\StartTime
        Instances()\IsRunning = #False
      EndIf
    EndIf
    
  EndProcedure

  Procedure.l Consult(P_ChronoID.l)
    
    If SearchInstances(P_ChronoID) <> -1
      If Instances()\IsRunning = #True
        TotalTime.l = Instances()\TotalTime + ElapsedMilliseconds() - Instances()\StartTime
      Else
        TotalTime = Instances()\TotalTime
      EndIf
    EndIf
    
    ProcedureReturn TotalTime
  EndProcedure
  
  Procedure.s Format(ChronoID.l, TimeMask.s)
    
    If SearchInstances(P_ChronoID) <> -1
      
      MilliSeconds = Consult(P_ChronoID)
      
      ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ; <<<<< On fait l'extraction des jours, Heures, minutes, secondes et des MS <<<<<
      
      If MilliSeconds < 0 
        MilliSeconds = MilliSeconds * -1
      EndIf 
      
      Days = MilliSeconds / 86400000 
      MilliSeconds % 86400000
      
      Hours = MilliSeconds / 3600000
      MilliSeconds % 3600000
      
      Minutes = MilliSeconds / 60000
      MilliSeconds % 60000
      
      Seconds = MilliSeconds / 1000
      MilliSeconds % 1000
      
      ; <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      ; <<<<< On s'occupe du filtre de sortie <<<<<
      
      If FindString(TimeMask, "%dd", 1)
        TimeMask = ReplaceString(TimeMask,"%dd", RSet(Str(Days), 2, "0"))
      EndIf 
      
      If FindString(TimeMask, "%hh", 1)
        TimeMask = ReplaceString(TimeMask,"%hh", RSet(Str(Hours), 2, "0"))
      EndIf 
      
      If FindString(TimeMask, "%mm", 1)
        TimeMask = ReplaceString(TimeMask,"%mm", RSet(Str(Minutes), 2, "0"))
      EndIf 
      
      If FindString(TimeMask, "%ss", 1)
        TimeMask = ReplaceString(TimeMask,"%ss", RSet(Str(Seconds), 2, "0"))
      EndIf 
      
      If FindString(TimeMask, "%mss", 1)
        TimeMask = ReplaceString(TimeMask,"%mss", RSet(Str(MilliSeconds), 3, "0"))
      EndIf
      
    EndIf
    
    ProcedureReturn TimeMask
  EndProcedure
  
EndModule

CompilerIf #PB_Compiler_IsMainFile
  
  Chrono::New(0)
  Chrono::Start(0)
  
  Delay(1)
  
  Chrono::Stop(0) 
  
  Debug Chrono::Consult(0)
  Debug Chrono::Format(0, "%ss:%mss")
  
CompilerEndIf

; <<<<<<<<<<<<<<<<<<<<<<<<<<
; <<<<< FIN DU FICHIER <<<<<
; <<<<<<<<<<<<<<<<<<<<<<<<<<
; IDE Options = PureBasic 5.70 beta 1 (Linux - x64)
; Folding = -h-
; EnableXP
; CompileSourceDirectory